#ifndef __LCD_H_
#define __LCD_H_


/***************************LCD CONFIG*********************/
#define LCD_7INCH
//#define LCD_43INCH

#define MODE_888
//#define MODE_565

/*********************************************************/

#ifdef LCD_43INCH

#define C_GLCD_V_SIZE           272
#define C_GLCD_V_PULSE          10   //ֱͬźŵ
#define C_GLCD_V_FRONT_PORCH    3   //ֱͬźŵǰ
#define C_GLCD_V_BACK_PORCH     12   //ֱͬźŵĺ

#define C_GLCD_H_SIZE           480
#define C_GLCD_H_PULSE          2	  //ˮƽͬźŵ
#define C_GLCD_H_FRONT_PORCH    18   //ˮƽͬźŵǰ
#define C_GLCD_H_BACK_PORCH     43  //ˮƽͬźŵĺ
 
#elif defined LCD_7INCH

#define C_GLCD_REFRESH_FREQ     (50)	// Hz

#define C_GLCD_V_SIZE           480
#define C_GLCD_V_PULSE          7   //ֱͬźŵ
#define C_GLCD_V_FRONT_PORCH    3   //ֱͬźŵǰ
#define C_GLCD_V_BACK_PORCH     12   //ֱͬźŵĺ


#define C_GLCD_H_SIZE           800
#define C_GLCD_H_PULSE          2	  //ˮƽͬźŵ
#define C_GLCD_H_FRONT_PORCH    18   //ˮƽͬźŵǰ
#define C_GLCD_H_BACK_PORCH     43  //ˮƽͬźŵĺ

#endif



#ifdef MODE_565 

    /* LCD color */
    #define White          0xFFFF
    #define Black          0x0000
    #define Blue           0xF800
    #define Red            0x001F
    #define Magenta        0xF81F
    #define Green          0x07E0
    #define Yellow         0x07FF
		#define purple         0xf81f

#elif defined MODE_888	 //
    /* LCD color */
    #define White          0xFFFFFF
    #define Black          0x000000
    #define Blue           0xFF0000
    #define Red            0x0000FF
    #define Green          0x00FF00
    #define Yellow         0x00FFFF
    #define purple         0xff00ff

#endif

/************************** PRIVATE DEFINITIONS *************************/
// #define LCD_WIDTH		800	
// #define LCD_HEIGHT		480

#define LOGO_WIDTH		110
#define LOGO_HEIGHT		42

#define FRAMEBUFFER_ADDR        0x28000000




void LCD_Init (void);
void lcd_Clear(uint32_t color);
void LCD_SetPoint(uint16_t Xpos,uint16_t Ypos,uint32_t color);\
void LCD_Drawcircle(int x0, int y0, int r, int color);
void LCD_DrawLine( uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1 , uint32_t color );
void PutChar( uint16_t Xpos, uint16_t Ypos, uint8_t ASCI, uint32_t charColor, uint32_t bkColor );
void GUI_Text(uint16_t Xpos, uint16_t Ypos, uint8_t *str,uint32_t Color, uint32_t bkColor);
void lcd_Clear(uint32_t color);
void lcd_display_coord(uint16_t x,uint16_t y,uint32_t color,uint32_t color1);


#endif

