#include "lpc43xx_gpio.h"
#include "lpc43xx_scu.h"
//#include "lpc43xx_libcfg.h"
#include "lpc43xx_cgu.h"
#include "lpc43xx_ssp.h"

#include "lpc4357_uart.h"
#include "TouchPanel.h"
#include "LCD.h"

#define BUF_SIZE    0x01  // 1 Byte
// SPI Data Setup structure variable
SSP_DATA_SETUP_Type dataCfg;
// SSP Configuration structure variable
SSP_CFG_Type SSP_ConfigStruct;

/* Private variables ---------------------------------------------------------*/
Matrix matrix ;
Coordinate  display ;


Coordinate ScreenSample[3];
Coordinate ScreenSample[3];

Coordinate DisplaySample[3] =   {
                                            { 60, 60 },
											{ C_GLCD_H_SIZE-50,50},
                                            { C_GLCD_H_SIZE/2,C_GLCD_V_SIZE-40}
	                            } ;

/* Private define ------------------------------------------------------------*/
#define THRESHOLD 2

                     
// /*******************************************************************************
// * Function Name  : delay_ms
// * Description    : Delay Time
// * Input          : - cnt: Delay Time
// * Output         : None
// * Return         : None
// * Return         : None
// * Attention		 : None
// *******************************************************************************/
// void delay_ms(uint32_t ms)    
// { 
// 	uint16_t i,j; 
// 	for( i = 0; i < ms; i++ )
// 	{ 
// 		for( j = 0; j < 1141; j++ );
// 	}
// } 

// /*******************************************************************************
// * Function Name  : delay_ms
// * Description    : Delay Time
// * Input          : - cnt: Delay Time
// * Output         : None
// * Return         : None
// * Return         : None
// * Attention		 : None
// *******************************************************************************/
// void delay_us(uint32_t cnt)    
// { 
//   uint16_t i;
//   for(i = 0;i<cnt;i++)
//   {
//      uint8_t us = 12;
//      while (us--)
//      {
//        ;   
//      }
//   }
// }

uint8_t SPI_WriteByte(uint8_t  data)
{
    uint8_t data_rx[BUF_SIZE];
    uint8_t rl;

    dataCfg.length = BUF_SIZE;
    dataCfg.tx_data = &data;
    rl = SSP_ReadWrite (LPC_SSP0,&dataCfg,SSP_TRANSFER_POLLING);
    if(rl != 0)
    {
        dataCfg.rx_data = &data_rx;
        return  data_rx[0];
    }
    return 0;
}




void SSPIx_Init(void)
{
	
    SSP_CFG_Type SSP_ConfigStruct;

		/* Configure SSP0 pins*/
	scu_pinmux(SSP0_SCK_Pin_name_PORT,SSP0_SCK_Pin_name_BIT,MD_PLN_FAST,SSP0_SCK_Pin_Function);	    // SCK0
 	scu_pinmux(SSP0_MISO_Pin_name_PORT,SSP0_MISO_Pin_name_BIT,MD_PLN_FAST,SSP0_MISO_Pin_Function);	// MISO0
 	scu_pinmux(SSP0_MOSI_Pin_name_PORT,SSP0_MOSI_Pin_name_BIT,MD_PLN_FAST,SSP0_MOSI_Pin_Function);	// MOSI
	
	// initialize SSP configuration structure to default
	SSP_ConfigStructInit(&SSP_ConfigStruct);

	// Initialize SSP peripheral with parameter given in structure above
	SSP_Init(LPC_SSP0, &SSP_ConfigStruct);

	// Enable SSP peripheral
	SSP_Cmd(LPC_SSP0, ENABLE);
}


void touch_init(void)
{

	scu_pinmux(Touch_IRQ_Pin_name_PORT,Touch_IRQ_Pin_name_BIT,MD_PUP | MD_EZI,Touch_IRQ_Pin_Function);	// IRQ
	GPIO_SetDir(Touch_IRQ_GPIO_PORT,(1<<Touch_IRQ_GPIO_BIT), 0);    //- 0: Input.

	scu_pinmux(Touch_BUSY_Pin_name_PORT,Touch_BUSY_Pin_name_BIT,MD_PUP | MD_EZI,Touch_BUSY_Pin_Function);	// BUSY	
	GPIO_SetDir(Touch_BUSY_GPIO_PORT,(1<<Touch_BUSY_GPIO_BIT), 0);    //- 0: Input.	
	
	scu_pinmux(LCD_7INCH_Touch_CS_Pin_name_PORT,LCD_7INCH_Touch_CS_Pin_name_BIT,MD_PUP,LCD_7INCH_Touch_CS_Pin_Function);	// CS	
	GPIO_SetDir(LCD_7INCH_Touch_CS_GPIO_PORT,(1<<LCD_7INCH_Touch_CS_GPIO_BIT), 1);    //- 1: Output	
	scu_pinmux(LCD_43INCH_Touch_CS_Pin_name_PORT,LCD_43INCH_Touch_CS_Pin_name_BIT,MD_PUP,LCD_43INCH_Touch_CS_Pin_Function);	// CS	
	GPIO_SetDir(LCD_43INCH_Touch_CS_GPIO_PORT,(1<<LCD_43INCH_Touch_CS_GPIO_BIT), 1);    //- 1: Output	

#ifdef LCD_43INCH
		LCD_43INCH_TouchPanel_nCS_L
		LCD_7INCH_TouchPanel_nCS_H;
#else
		LCD_43INCH_TouchPanel_nCS_H
		LCD_7INCH_TouchPanel_nCS_L;
#endif

	SSPIx_Init();
	
    
        
}


/*******************************************************************************
* Function Name  : TP_GetAdXY
* Description    : Read ADS7843
* Input          : None
* Output         : None
* Return         : 
* Attention		 : None
*******************************************************************************/
void TP_GetAdXY(uint32_t *x,uint32_t *y)  
{ 
	  uint32_t buf,tmpx;
    uint32_t tmpy;
	
    TouchPanel_Enable;
    SPI_WriteByte(CHX);
		while(BUSY_INT_IN);  
		buf=SPI_WriteByte(0X00);
	  tmpx = buf<<8;
		buf=SPI_WriteByte(0X00);
	  tmpx |= buf;
	  tmpx >>= 3;
		tmpx &=0xfff;
	
    SPI_WriteByte(CHY);
    while(BUSY_INT_IN);
		buf=SPI_WriteByte(0X00);
	  tmpy = buf<<8;
		buf=SPI_WriteByte(0X00);
	  tmpy |= buf;
	  tmpy >>= 3;
		tmpy &=0xfff;
		
    SPI_WriteByte( 1<<7 ); /* ٴδж */
		while(BUSY_INT_IN); 
    TouchPanel_Disable;
	
		*x=tmpx; 
		*y=tmpy; 		
	
}



/*******************************************************************************
* Function Name  : Read_Ads7846
* Description    : Get TouchPanel X Y
* Input          : None
* Output         : None
* Return         : Coordinate *
* Attention		 : None
*******************************************************************************/
Coordinate * Read_XTP2046(void)
{
	uint32_t XAD,YAD; 
  static Coordinate  screen;
  uint32_t m0,m1,m2,TP_X[1],TP_Y[1],temp[3];
  uint8_t count=0;
  int buffer[2][9]={{0},{0}};
  
  do
  {		   
    TP_GetAdXY(TP_X,TP_Y);  
	buffer[0][count]=TP_X[0];  
	buffer[1][count]=TP_Y[0];
	count++;  
  }

  while(!TP_INT_IN&& count<9);  /* TP_INT_IN  */
  if(count==9)   /* Average X Y  */ 
  {
	/* Average X  */
    temp[0]=(buffer[0][0]+buffer[0][1]+buffer[0][2])/3;
	temp[1]=(buffer[0][3]+buffer[0][4]+buffer[0][5])/3;
	temp[2]=(buffer[0][6]+buffer[0][7]+buffer[0][8])/3;

	m0=temp[0]-temp[1];
	m1=temp[1]-temp[2];
	m2=temp[2]-temp[0];

	m0=m0>0?m0:(-m0);
    m1=m1>0?m1:(-m1);
	m2=m2>0?m2:(-m2);

	if( m0>THRESHOLD  &&  m1>THRESHOLD  &&  m2>THRESHOLD ) return 0;

	if(m0<m1)
	{
	  if(m2<m0) 
	    screen.x=(temp[0]+temp[2])/2;
	  else 
	    screen.x=(temp[0]+temp[1])/2;	
	}
	else if(m2<m1) 
	  screen.x=(temp[0]+temp[2])/2;
	else 
	  screen.x=(temp[1]+temp[2])/2;

	/* Average Y  */
    temp[0]=(buffer[1][0]+buffer[1][1]+buffer[1][2])/3;
	temp[1]=(buffer[1][3]+buffer[1][4]+buffer[1][5])/3;
	temp[2]=(buffer[1][6]+buffer[1][7]+buffer[1][8])/3;
	m0=temp[0]-temp[1];
	m1=temp[1]-temp[2];
	m2=temp[2]-temp[0];
	m0=m0>0?m0:(-m0);
	m1=m1>0?m1:(-m1);
	m2=m2>0?m2:(-m2);
	if(m0>THRESHOLD&&m1>THRESHOLD&&m2>THRESHOLD) return 0;

	if(m0<m1)
	{
	  if(m2<m0) 
	    screen.y=(temp[0]+temp[2])/2;
	  else 
	    screen.y=(temp[0]+temp[1])/2;	
    }
	else if(m2<m1) 
	   screen.y=(temp[0]+temp[2])/2;
	else
	   screen.y=(temp[1]+temp[2])/2;
	
	
		XAD=32;
		/*x*/
		PutChar(XAD,16,48+screen.x/1000,White,0x555555); 			XAD=XAD+8;
		PutChar(XAD,16,48+screen.x%1000/100,White,0x555555);  XAD=XAD+8; 
		PutChar(XAD,16,48+screen.x%100/10,White,0x555555); 	  XAD=XAD+8;
		PutChar(XAD,16,48+screen.x%10,White,0x555555);     		XAD=XAD+8;
		/*y*/
		XAD=32;
		PutChar(XAD,32,48+screen.y/1000,White,0x555555);   		 XAD=XAD+8;
		PutChar(XAD,32,48+screen.y%1000/100,White,0x555555);   XAD=XAD+8;
		PutChar(XAD,32,48+screen.y%100/10,White,0x555555);     XAD=XAD+8;
		PutChar(XAD,32,48+screen.y%10,White,0x555555);         XAD=XAD+8;
	
	
	return &screen;
    
  }  
  return 0; 
}



/*******************************************************************************
* Function Name  : setCalibrationMatrix
* Description    : Calculate K A B C D E F
* Input          : None
* Output         : None
* Return         : 
* Attention		 : None
*******************************************************************************/
FunctionalState setCalibrationMatrix( Coordinate * displayPtr,
                          Coordinate * screenPtr,
                          Matrix * matrixPtr)
{

  FunctionalState retTHRESHOLD = ENABLE ;
  /* K(X0X2) (Y1Y2)(X1X2) (Y0Y2) */
  matrixPtr->Divider = ((screenPtr[0].x - screenPtr[2].x) * (screenPtr[1].y - screenPtr[2].y)) - 
                       ((screenPtr[1].x - screenPtr[2].x) * (screenPtr[0].y - screenPtr[2].y)) ;
  if( matrixPtr->Divider == 0 )
  {
    retTHRESHOLD = DISABLE;
  }
  else
  {
    /* A((XD0XD2) (Y1Y2)(XD1XD2) (Y0Y2))K	*/
    matrixPtr->An = ((displayPtr[0].x - displayPtr[2].x) * (screenPtr[1].y - screenPtr[2].y)) - 
                    ((displayPtr[1].x - displayPtr[2].x) * (screenPtr[0].y - screenPtr[2].y)) ;
	/* B((X0X2) (XD1XD2)(XD0XD2) (X1X2))K	*/
    matrixPtr->Bn = ((screenPtr[0].x - screenPtr[2].x) * (displayPtr[1].x - displayPtr[2].x)) - 
                    ((displayPtr[0].x - displayPtr[2].x) * (screenPtr[1].x - screenPtr[2].x)) ;
    /* C(Y0(X2XD1X1XD2)+Y1(X0XD2X2XD0)+Y2(X1XD0X0XD1))K */
    matrixPtr->Cn = (screenPtr[2].x * displayPtr[1].x - screenPtr[1].x * displayPtr[2].x) * screenPtr[0].y +
                    (screenPtr[0].x * displayPtr[2].x - screenPtr[2].x * displayPtr[0].x) * screenPtr[1].y +
                    (screenPtr[1].x * displayPtr[0].x - screenPtr[0].x * displayPtr[1].x) * screenPtr[2].y ;
    /* D((YD0YD2) (Y1Y2)(YD1YD2) (Y0Y2))K	*/
    matrixPtr->Dn = ((displayPtr[0].y - displayPtr[2].y) * (screenPtr[1].y - screenPtr[2].y)) - 
                    ((displayPtr[1].y - displayPtr[2].y) * (screenPtr[0].y - screenPtr[2].y)) ;
    /* E((X0X2) (YD1YD2)(YD0YD2) (X1X2))K	*/
    matrixPtr->En = ((screenPtr[0].x - screenPtr[2].x) * (displayPtr[1].y - displayPtr[2].y)) - 
                    ((displayPtr[0].y - displayPtr[2].y) * (screenPtr[1].x - screenPtr[2].x)) ;
    /* F(Y0(X2YD1X1YD2)+Y1(X0YD2X2YD0)+Y2(X1YD0X0YD1))K */
    matrixPtr->Fn = (screenPtr[2].x * displayPtr[1].y - screenPtr[1].x * displayPtr[2].y) * screenPtr[0].y +
                    (screenPtr[0].x * displayPtr[2].y - screenPtr[2].x * displayPtr[0].y) * screenPtr[1].y +
                    (screenPtr[1].x * displayPtr[0].y - screenPtr[0].x * displayPtr[1].y) * screenPtr[2].y ;
  }
  return( retTHRESHOLD ) ;
}

/*******************************************************************************
* Function Name  : getDisplayPoint
* Description    : Touch panel X Y to display X Y
* Input          : None
* Output         : None
* Return         : 
* Attention		 : None
*******************************************************************************/
FunctionalState getDisplayPoint(Coordinate * displayPtr,
                     Coordinate * screenPtr,
                     Matrix * matrixPtr )
{
  FunctionalState retTHRESHOLD =ENABLE ;

  if( matrixPtr->Divider != 0 )
  {
    /* XD = AX+BY+C */        
    displayPtr->x = ( (matrixPtr->An * screenPtr->x) + 
                      (matrixPtr->Bn * screenPtr->y) + 
                       matrixPtr->Cn 
                    ) / matrixPtr->Divider ;

	/* YD = DX+EY+F */        
    displayPtr->y = ( (matrixPtr->Dn * screenPtr->x) + 
                      (matrixPtr->En * screenPtr->y) + 
                       matrixPtr->Fn 
                    ) / matrixPtr->Divider ;
  }
  else
  {
    retTHRESHOLD = DISABLE;
  }
  return(retTHRESHOLD);
} 

/*******************************************************************************
* Function Name  : TouchPanel_Calibrate
* Description    : 
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void TouchPanel_Calibrate(void)
{
  uint8_t i;
  Coordinate * Ptr;

  for(i=0;i<3;i++)
  {
    lcd_Clear(0X0000);
    GUI_Text(120,40,"Touch crosshair to calibrate",White,Black);
    timer_delay_ms(200);
   lcd_display_coord(DisplaySample[i].x,DisplaySample[i].y,Red,Blue);
   do
   {                                 
     Ptr=Read_XTP2046();

   }
   while( Ptr == (void*)0 );
   ScreenSample[i].x= Ptr->x; ScreenSample[i].y= Ptr->y;
  }
  setCalibrationMatrix( &DisplaySample[0],&ScreenSample[0],&matrix );
  lcd_Clear(0X0000);
} 

void TouchPanel_Calibrate2(void)
{
	
#ifdef LCD_43INCH 

  ScreenSample[0].x = 3218; ScreenSample[0].y= 455;
  ScreenSample[1].x = 2992; ScreenSample[1].y= 3298;
  ScreenSample[2].x = 489; ScreenSample[2].y= 2048; 
									 
#elif defined LCD_7INCH	 
  ScreenSample[0].x = 954; ScreenSample[0].y= 689;
  ScreenSample[1].x = 770; ScreenSample[1].y= 3540;
  ScreenSample[2].x = 3350; ScreenSample[2].y= 2071; 

#endif
  setCalibrationMatrix( &DisplaySample[0],&ScreenSample[0],&matrix );
  lcd_Clear(Black);
	GUI_Text(0,0,"Sketchpad:",Red,White);
} 




/*******************************************************************************
* Function Name  : TP_DrawPoint
* Description    : 
* Input          : - Xpos: Row Coordinate
*                  - Ypos: Line Coordinate 
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void TP_DrawPoint(uint16_t Xpos,uint16_t Ypos)
{
	
	LCD_Drawcircle(Xpos,Ypos,1,Blue);
	LCD_Drawcircle(Xpos,Ypos,2,Blue);
	LCD_Drawcircle(Xpos,Ypos,3,Blue);
	LCD_Drawcircle(Xpos,Ypos,4,Blue);
	LCD_Drawcircle(Xpos,Ypos,5,Blue);
}	
/*********************************************************************************************************
      END FILE
*********************************************************************************************************/

