#include "DS18B20.h"



#define SET_DQ() GPIO_SetValue(DS18B20_GPIO_PORT,(1<<DS18B20_GPIO_BIT));	 
#define CLR_DQ() GPIO_ClearValue(DS18B20_GPIO_PORT,(1<<DS18B20_GPIO_BIT));

#define OUT_DQ() GPIO_SetDir(DS18B20_GPIO_PORT,(1<<DS18B20_GPIO_BIT), 1); 
#define IN_DQ()  GPIO_SetDir(DS18B20_GPIO_PORT,(1<<DS18B20_GPIO_BIT), 0);

#define GET_DQ() (GPIO_ReadValue(DS18B20_GPIO_PORT) & (1<<DS18B20_GPIO_BIT))

void delay_us (unsigned long zms) 
{
 	unsigned long i,j;
	for(j=zms;j>0;j--)
		for(i=20;i>0;i--);
}

//-----λ-----
void resetOnewire(void) 
{
	OUT_DQ();
    CLR_DQ();
    delay_us(750);
    SET_DQ();
	IN_DQ(); 
	while(GET_DQ());
	while(!(GET_DQ()));
	OUT_DQ();
}

//----------
uint8_t rOnewire(void)
{
    uint8_t data=0,i=0;
    for(i=0;i<8;i++)
    {
		data=data>>1;
		OUT_DQ();
        CLR_DQ();
        delay_us(5);
		SET_DQ();
		delay_us(15);
		IN_DQ();
        if(GET_DQ()) data|=0x80;
        else while(!(GET_DQ()));
		delay_us(60);
		SET_DQ();
	}
	return(data);
}
//-----д-----
void wOnewire(uint8_t data)
{
    uint8_t i=0;
	OUT_DQ();
    for(i=0;i<8;i++)
    {
        if(data&0x01)
		{
            CLR_DQ();
            delay_us(5);
            SET_DQ();
            delay_us(85); //65
		}
   	 	else
   	 	{
       		CLR_DQ(); 
        	delay_us(90);  //65
        	SET_DQ();
        	delay_us(5);
    	}
    	data=data>>1;
    }
}
uint8_t* readID(void) 
{ 
	uint8_t ID[8],i,*p;
	resetOnewire(); 
	wOnewire(0x33);
	for(i=0;i<8;i++)
	{ID[i]=rOnewire();}
	p=ID;
	return p;
}

//-----DS18B20ת¶-----
void convertDs18b20(void) 
{ 
    resetOnewire(); 
    wOnewire(0xcc); 
    wOnewire(0x44); 
} 
//------------DS18BB0¶----------
unsigned int readTemp(void) 
{ 
	uint8_t temp1,temp2;
	convertDs18b20();
    resetOnewire(); 
    wOnewire(0xcc); 
    wOnewire(0xbe); 	
    temp1=rOnewire(); 
    temp2=rOnewire(); 
	return (((temp2<<8)|temp1)*6.25); //0.0625=xx, 0.625=xx.x, 6.25=xx.xx
}

