/**********************************************************************
* $Id$		Gpio_LedBlinky.c	2011-06-02
*//**
* @file		Gpio_LedBlinky.c
* @brief	This example describes how to use GPIO to drive LEDs
* @version	1.0
* @date		02. June. 2011
* @author	NXP MCU SW Application Team
*
* Copyright(C) 2011, NXP Semiconductor
* All rights reserved.
*
***********************************************************************
* Software that is described herein is for illustrative purposes only
* which provides customers with programming information regarding the
* products. This software is supplied "AS IS" without any warranties.
* NXP Semiconductors assumes no responsibility or liability for the
* use of the software, conveys no license or title under any patent,
* copyright, or mask work right to the product. NXP Semiconductors
* reserves the right to make changes in the software without
* notification. NXP Semiconductors also make no representation or
* warranty that such application will be suitable for the specified
* use without further testing or modification.
**********************************************************************/
#include "lpc43xx_gpio.h"
#include "lpc43xx_scu.h"
#include "lpc43xx_libcfg_default.h"
#include "lpc43xx_cgu.h"
#include "lpc4357_uart.h"
#include "LPC4357_IO.h"
#include "spifi_rom_api.h"

//#include "lpc43xx_utils.h"


/* Example group ----------------------------------------------------------- */
/** @defgroup Gpio_LedBlinky	Gpio_LedBlinky
 * @ingroup GPIO_Examples
 * @{
 */


/************************** PRIVATE VARIABLES *************************/
uint32_t msec;
uint32_t key;


/* With ARM and GHS toolsets, the entry point is main() - this will
   allow the linker to generate wrapper code to setup stacks, allocate
   heap area, and initialize and copy code and data segments. For GNU
   toolsets, the entry point is through __start() in the crt0_gnu.asm
   file, and that startup code will setup stacks and data */
int main(void)
{
	
  SystemInit();
	CGU_Init();
	
//	if(CGU_SetPLL1(16) != CGU_ERROR_SUCCESS) while(1);
//	CGU_UpdateClock();
	UART_Configuration();
	printf("Core is clocked at %1.1f MHz\r\n", ((float)CGU_GetPCLKFrequency(CGU_PERIPHERAL_M4CORE)/1.0E6));

	LED_GPIO_Configuration();
	JOY_KEY_Configuration();
	key=5;
	while (1)
	{                           					
		if(!(GPIO_ReadValue(JOY_A_GPIO_PORT) & (1<<JOY_A_GPIO_BIT)))
			key=1;
		if(!(GPIO_ReadValue(JOY_B_GPIO_PORT) & (1<<JOY_B_GPIO_BIT)))
			key=2;
		if(!(GPIO_ReadValue(JOY_C_GPIO_PORT) & (1<<JOY_C_GPIO_BIT)))
			key=3;
		if(!(GPIO_ReadValue(JOY_D_GPIO_PORT) & (1<<JOY_D_GPIO_BIT)))
			key=4;
		if(!(GPIO_ReadValue(JOY_PRESS_GPIO_PORT) & (1<<JOY_PRESS_GPIO_BIT)))
			key=5;
		if(!(GPIO_ReadValue(KEY1_GPIO_PORT) & (1<<KEY1_GPIO_BIT)))
			key=3;
		if(!(GPIO_ReadValue(KEY2_GPIO_PORT) & (1<<KEY2_GPIO_BIT)))
			key=4;
		switch (key)
		{
			case 0:	
						GPIO_SetValue(LED1_GPIO_PORT, (1<<LED1_GPIO_BIT));
            GPIO_SetValue(LED2_GPIO_PORT, (1<<LED2_GPIO_BIT));
            GPIO_SetValue(LED3_GPIO_PORT, (1<<LED3_GPIO_BIT));
						GPIO_SetValue(LED4_GPIO_PORT, (1<<LED4_GPIO_BIT));
            timer_delay_ms(100);			                                                                               timer_delay_ms(100);
						GPIO_ClearValue(LED1_GPIO_PORT, (1<<LED1_GPIO_BIT));
						GPIO_ClearValue(LED2_GPIO_PORT, (1<<LED2_GPIO_BIT));
						GPIO_ClearValue(LED3_GPIO_PORT, (1<<LED3_GPIO_BIT));
						GPIO_ClearValue(LED4_GPIO_PORT, (1<<LED4_GPIO_BIT));
            timer_delay_ms(100);
			break;
			case 1:
			GPIO_SetValue(LED1_GPIO_PORT, (1<<LED1_GPIO_BIT));
			timer_delay_ms(100);
			GPIO_ClearValue(LED1_GPIO_PORT, (1<<LED1_GPIO_BIT));	
			timer_delay_ms(100);
				break;
			case 2:
			GPIO_SetValue(LED2_GPIO_PORT, (1<<LED2_GPIO_BIT));
			timer_delay_ms(100);
			GPIO_ClearValue(LED2_GPIO_PORT, (1<<LED2_GPIO_BIT));
			timer_delay_ms(100);
				break;
			case 3:
			GPIO_SetValue(LED3_GPIO_PORT, (1<<LED3_GPIO_BIT));
			timer_delay_ms(100);
			GPIO_ClearValue(LED3_GPIO_PORT, (1<<LED3_GPIO_BIT));
			timer_delay_ms(100);
				break;
			case 4:
			GPIO_SetValue(LED4_GPIO_PORT, (1<<LED4_GPIO_BIT));
			timer_delay_ms(100);
			GPIO_ClearValue(LED4_GPIO_PORT, (1<<LED4_GPIO_BIT));
			timer_delay_ms(100);
				break;
			case 5:
			GPIO_SetValue(LED1_GPIO_PORT, (1<<LED1_GPIO_BIT));
			timer_delay_ms(100);
			GPIO_ClearValue(LED1_GPIO_PORT, (1<<LED1_GPIO_BIT));
			GPIO_SetValue(LED2_GPIO_PORT, (1<<LED2_GPIO_BIT));
			timer_delay_ms(100);
			GPIO_ClearValue(LED2_GPIO_PORT, (1<<LED2_GPIO_BIT));
			GPIO_SetValue(LED3_GPIO_PORT, (1<<LED3_GPIO_BIT));
			timer_delay_ms(100);
			GPIO_ClearValue(LED3_GPIO_PORT, (1<<LED3_GPIO_BIT));
			GPIO_SetValue(LED4_GPIO_PORT, (1<<LED4_GPIO_BIT));
			timer_delay_ms(100);
			GPIO_ClearValue(LED4_GPIO_PORT, (1<<LED4_GPIO_BIT));
				break;
		}												
				
		
	}
}

#ifdef  DEBUG
/*******************************************************************************
* @brief		Reports the name of the source file and the source line number
* 				where the CHECK_PARAM error has occurred.
* @param[in]	file Pointer to the source file name
* @param[in]    line assert_param error line source number
* @return		None
*******************************************************************************/
void check_failed(uint8_t *file, uint32_t line)
{
	/* User can add his own implementation to report the file name and line number,
	 ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

	/* Infinite loop */
	while(1);
}
#endif

/**
 * @}
 */
