/**********************************************************************
* $Id$		Gpio_LedBlinky.c	2011-06-02
*//**
* @file		Gpio_LedBlinky.c
* @brief	This example describes how to use GPIO to drive LEDs
* @version	1.0
* @date		02. June. 2011
* @author	NXP MCU SW Application Team
*
* Copyright(C) 2011, NXP Semiconductor
* All rights reserved.
*
***********************************************************************
* Software that is described herein is for illustrative purposes only
* which provides customers with programming information regarding the
* products. This software is supplied "AS IS" without any warranties.
* NXP Semiconductors assumes no responsibility or liability for the
* use of the software, conveys no license or title under any patent,
* copyright, or mask work right to the product. NXP Semiconductors
* reserves the right to make changes in the software without
* notification. NXP Semiconductors also make no representation or
* warranty that such application will be suitable for the specified
* use without further testing or modification.
**********************************************************************/
#include "lpc43xx_gpio.h"
#include "lpc43xx_scu.h"
#include "lpc43xx_libcfg_default.h"
#include "lpc43xx_cgu.h"
#include "LPC4357_IO.h"
#include "lpc4357_uart.h"
#include "AT24C02.h"

extern uint8_t wrdat[];	 
extern uint8_t rddat[];

/* With ARM and GHS toolsets, the entry point is main() - this will
   allow the linker to generate wrapper code to setup stacks, allocate
   heap area, and initialize and copy code and data segments. For GNU
   toolsets, the entry point is through __start() in the crt0_gnu.asm
   file, and that startup code will setup stacks and data */
int main(void)
{
	uint32_t i,value=0;	
  SystemInit();
	CGU_Init();
	LED_GPIO_Configuration();
	UART_Configuration();
//	UART_NVIC_Config();
	printf("AT24C02 test procedures!!\r\n");

	I2Cx_Init(200000);

	printf("Wirte data:\r\n");
	for(i=0;i<8;i++)
	printf("0x%x ",wrdat[i+1]);


	if (I2Cx_Wirte() == (-1))
		printf("Error while sending data\r\n");
	else
	printf("\r\nData write OK \r\n");

	/* Receive data ---------------------------------------------------------- */
		if (I2Cx_Read() == (-1))
		printf("Error while reading data\r\n");
	else
		printf("\r\nread data OK\r\n");

	printf("Read data:\r\n");
	for(i=0;i<8;i++)
	printf("0x%x ",rddat[i]);
	
//	verify
	
	for(i=0;i<8;i++)
	{
		if(wrdat[i+1]==rddat[i])
		value++;	
	}

	if(value==8)
	printf("\r\nE2PROM TEST OK\r\n");
	else
	printf("\r\nE2PROM TEST error\r\n");
	while(1);
	
}


#ifdef  DEBUG
/*******************************************************************************
* @brief		Reports the name of the source file and the source line number
* 				where the CHECK_PARAM error has occurred.
* @param[in]	file Pointer to the source file name
* @param[in]    line assert_param error line source number
* @return		None
*******************************************************************************/
void check_failed(uint8_t *file, uint32_t line)
{
	/* User can add his own implementation to report the file name and line number,
	 ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

	/* Infinite loop */
	while(1);
}
#endif

/**
 * @}
 */
