#include "lpc43xx_gpio.h"
#include "lpc43xx_scu.h"
#include "lpc43xx_libcfg.h"
#include "lpc43xx_cgu.h"
#include "lpc4357_uart.h"
#include "LCD.h"


extern void SDRAM_Init (void);

int main(void)
{
   uint32_t tmpx=0;
   uint32_t tmpy=0;	
	SystemInit();
//	CGU_Init();
	
	CGU_SetXTALOSC(12000000);
	CGU_EnableEntity(CGU_CLKSRC_XTAL_OSC, ENABLE);
	CGU_EntityConnect(CGU_CLKSRC_XTAL_OSC, CGU_CLKSRC_PLL1);
	// Disable PLL1 CPU hang???
	//CGU_EnableEntity(CGU_CLKSRC_PLL1, DISABLE);
	CGU_SetPLL1(15);
	CGU_EnableEntity(CGU_CLKSRC_PLL1, ENABLE);
	CGU_EntityConnect(CGU_CLKSRC_PLL1, CGU_BASE_M4);
	CGU_UpdateClock();
	
	UART_Configuration();
	printf("Core is clocked at %1.1f MHz\r\n", ((float)CGU_GetPCLKFrequency(CGU_PERIPHERAL_M4CORE)/1.0E6));
	printf("CGU_PERIPHERAL_EMC is clocked at %1.1f MHz\r\n", ((float)CGU_GetPCLKFrequency(CGU_PERIPHERAL_EMC)/1.0E6));
	printf("CGU_PERIPHERAL_LCD is clocked at %1.1f MHz\r\n", ((float)CGU_GetPCLKFrequency(CGU_PERIPHERAL_LCD)/1.0E6));

	SDRAM_Init();
	LCD_Init();	
	timer_delay_ms(1000);
	lcd_Clear(Blue);
	timer_delay_ms(1000);
	lcd_Clear(Red);
	timer_delay_ms(1000);
	lcd_Clear(Green);
	timer_delay_ms(1000);

		lcd_Clear(purple);
    LCD_DrawLine( 0, 0, 240, 272 , White );
    LCD_DrawLine( 53, 0, 240, 272 , Black );
    LCD_DrawLine( 53*2, 0, 240, 272 , Blue );
    LCD_DrawLine( 53*3,  0, 240, 272 , Red );
    LCD_DrawLine( 53*4, 0, 240, 272 , Green );

    LCD_DrawLine( 53*5, 0, 240, 272 , Green );
    LCD_DrawLine( 53*6, 0, 240, 272 , Red );
    LCD_DrawLine( 53*7, 0, 240, 272 , Blue );
    LCD_DrawLine( 53*8, 0, 240, 272 , Black );
    LCD_DrawLine( 53*9, 0, 240, 272 , White );
    /*LCD Drawcircle*/

    LCD_Drawcircle(240,70,40,Blue);
    LCD_Drawcircle(240,70,39,Blue); 
    LCD_Drawcircle(240,70,38,Blue); 

    LCD_Drawcircle(180,70,40,Black);
    LCD_Drawcircle(180,70,39,Black);
    LCD_Drawcircle(180,70,38,Black);

    LCD_Drawcircle(300,70,40,Red);
    LCD_Drawcircle(300,70,39,Red);
    LCD_Drawcircle(300,70,38,Red);

    LCD_Drawcircle(210,110,40,Yellow);
    LCD_Drawcircle(210,110,39,Yellow);
    LCD_Drawcircle(210,110,38,Yellow);

    LCD_Drawcircle(270,110,40,Green);
    LCD_Drawcircle(270,110,39,Green);
    LCD_Drawcircle(270,110,38,Green);

    GUI_Text(120,170,"Welcome use Open1788 dinner plate,",White,purple);
    GUI_Text(120,186,"more products,please login  ",White,purple);
    GUI_Text(120,202,"www.waveshar.net",White,purple);     
    GUI_Text(350,218,"--jason",White,purple); 
		
	while(1);
		
}






