#ifndef __AT45DB_H
#define __AT45DB_H

#include "lpc_types.h"
#include "lpc43xx_timer.h"
#include "lpc43xx_gpio.h"
#include "LPC4357_IO.h"
#include "lpc4357_uart.h"
#include "lpc43xx_ssp.h"

extern uint8_t AT_RETURN_CODE[4];

#define BUF1_WRITE 0x84
#define BUF2_WRITE 0x87
#define BUF1_READ 0xD4
#define BUF2_READ 0xD6
#define BBUF1_TO_MM_PAGE_PROG_WITH_ERASE 0x83
#define BBUF2_TO_MM_PAGE_PROG_WITH_ERASE 0x86
#define MM_PAGE_TO_B1_XFER 0x53
#define MM_PAGE_TO_B2_XFER 0x55
#define PAGE_ERASE 0x81   // 512/528 bytes per page
#define SECTOR_ERASE 0x7C // 128k bytes per sector
#define READ_STATE_REGISTER 0xD7    ///0x57//0xD7
#define Read_ID 0x9F


#define AT45DBXX_Enable 	 AT45DBXX_nCS_L
#define AT45DBXX_Disable 	 AT45DBXX_nCS_H

#define AT45DBXX_nCS_L      GPIO_ClearValue(SSP0_CS_GPIO_PORT,(1<<SSP0_CS_GPIO_BIT));
#define AT45DBXX_nCS_H      GPIO_SetValue(SSP0_CS_GPIO_PORT,(1<<SSP0_CS_GPIO_BIT));

	
void SSPIx_Init(void);
/*static */void AT45DBXX_BUSY(void);
void AT45DBXX_Init(void);
void AT45DBXX_Read_ID(uint8_t *IData);
void write_buffer(uint16_t BufferOffset,uint8_t Data);
uint8_t read_buffer(uint16_t BufferOffset);

#endif

