#include "AT45DB.h"

#define BUF_SIZE    0x01   // 1 Byte
// SPI Data Setup structure variable
SSP_DATA_SETUP_Type dataCfg;
// SSP Configuration structure variable
SSP_CFG_Type SSP_ConfigStruct;


uint8_t SPIx_communication(uint8_t  data)
{
    uint8_t data_rx[BUF_SIZE];
    uint8_t rl;

    dataCfg.length = BUF_SIZE;
    dataCfg.tx_data = &data;
    rl = SSP_ReadWrite (LPC_SSP1,&dataCfg,SSP_TRANSFER_POLLING);
    if(rl != 0)
    {
        dataCfg.rx_data = &data_rx;
        return  data_rx[0];
//        _printf("%d\n",rl);
        //return (uint8_t)((uint8_t*)(dataCfg->rx_data));
    }
    return 0;

}

void SSPIx_Init(void)
{
//		SSP_DATA_SETUP_Type xferConfig;
	
		/* Configure SSP0 pins*/
	scu_pinmux(SSP1_SCK_Pin_name_PORT,SSP1_SCK_Pin_name_BIT,MD_PLN_FAST,SSP1_SCK_Pin_Function);	    // SCK0
 	scu_pinmux(SSP1_MISO_Pin_name_PORT,SSP1_MISO_Pin_name_BIT,MD_PLN_FAST,SSP1_MISO_Pin_Function);	// MISO0
 	scu_pinmux(SSP1_MOSI_Pin_name_PORT,SSP1_MOSI_Pin_name_BIT,MD_PLN_FAST,SSP1_MOSI_Pin_Function);	// MOSI
	scu_pinmux(SSP1_CS_Pin_name_PORT,SSP1_CS_Pin_name_BIT,MD_PUP,SSP1_CS_Pin_Function);	// CS
	GPIO_SetDir(SSP1_CS_GPIO_PORT,(1<<SSP1_CS_GPIO_BIT), 1);    //- 1: Output.
	
	

	// initialize SSP configuration structure to default
	SSP_ConfigStructInit(&SSP_ConfigStruct);
	// Initialize SSP peripheral with parameter given in structure above
	SSP_Init(LPC_SSP1, &SSP_ConfigStruct);

	// Enable SSP peripheral
	SSP_Cmd(LPC_SSP1, ENABLE);
}

void AT45DBXX_Init(void)
{
    AT45DBXX_nCS_H;
	SSPIx_Init();        
}

/*static */
void AT45DBXX_BUSY(void)
{
	AT45DBXX_Enable;
    while(!(0x80 & (SPIx_communication(READ_STATE_REGISTER))));
	AT45DBXX_Disable;	
}

void AT45DBXX_Read_ID(uint8_t *IData)
{
	uint8_t i;
	AT45DBXX_BUSY();
	AT45DBXX_Enable;	
    SPIx_communication(Read_ID);
    for(i=0;i<4;i++)
        IData[i]=SPIx_communication(0xff);
  	AT45DBXX_Disable;
}

void write_buffer(uint16_t BufferOffset,uint8_t Data)
{			
	AT45DBXX_Enable;
	SPIx_communication(0x84);			
	SPIx_communication(0xff);
	SPIx_communication((uint8_t)BufferOffset>>8);
	SPIx_communication((uint8_t)BufferOffset);		
	SPIx_communication(Data);
	AT45DBXX_Disable;
}

uint8_t read_buffer(uint16_t BufferOffset)
{		
uint8_t temp=0;

	AT45DBXX_Enable;
 	SPIx_communication(0xd4);
	SPIx_communication(0xff);
	SPIx_communication((uint8_t)BufferOffset>>8);
	SPIx_communication((uint8_t)BufferOffset);  
	SPIx_communication(0xff);
	temp=SPIx_communication(0xff);	
	AT45DBXX_Disable;
    return temp;		
}
