#include "lpc43xx_gpio.h"
#include "lpc43xx_scu.h"
//#include "lpc43xx_libcfg.h"
#include "lpc43xx_cgu.h"
#include "lpc4357_uart.h"
#include "LCD.h"
#include "TouchPanel.h"

/* Private variables ---------------------------------------------------------*/
extern Matrix matrix ;
extern Coordinate  display ;

extern void SDRAM_Init (void);


void DrawGrids(void);


int main(void)
{
	
	SystemInit();
	CGU_Init();
	
	UART_Configuration();
	printf("Core is clocked at %1.1f MHz\r\n", ((float)CGU_GetPCLKFrequency(CGU_PERIPHERAL_M4CORE)/1.0E6));
	printf("CGU_PERIPHERAL_EMC is clocked at %1.1f MHz\r\n", ((float)CGU_GetPCLKFrequency(CGU_PERIPHERAL_EMC)/1.0E6));
	printf("CGU_PERIPHERAL_LCD is clocked at %1.1f MHz\r\n", ((float)CGU_GetPCLKFrequency(CGU_PERIPHERAL_LCD)/1.0E6));

	SDRAM_Init();
	LCD_Init();
	
	timer_delay_ms(1000);
	
  touch_init();
//  TouchPanel_Calibrate();	
	TouchPanel_Calibrate2();	
	DrawGrids();
	GUI_Text(0,0,"Coordinate:",White,0x555555);
	GUI_Text(0,16,"XAD=",White,0x555555);
	GUI_Text(0,32,"yAD=",White,0x555555);
	 
	while(1)
	{	
			
 		getDisplayPoint(&display, Read_XTP2046(), &matrix );
 		TP_DrawPoint(display.x,display.y);

	}
}


void DrawGrids(void)
{
	uint16_t i;
	lcd_Clear(0x555555);
	
	for(i=0;i<C_GLCD_V_SIZE;i=i+10)
		LCD_DrawLine(0,i,C_GLCD_H_SIZE,i,Black);

	for(i=0;i<C_GLCD_H_SIZE;i=i+10)
		LCD_DrawLine(i,0,i,C_GLCD_V_SIZE,Black);
}





